/* IMPLEMENTATION ARI... VERSION 0.0 OF 26.5.97 BY WH, WU-WIEN & BU-ISTANBUL*/
/* this file:   ari.c */
/* this is the implementation of algorithm ARI
   see the file ari.doc for more information.
!!!DON`T CHANGE ANYTHING IN THAT FILE UNLESS YOU REALLY KNOW WHAT YOU DO!!!!
   Simple user changes can be done in the header-file ari.h*/


#include "ari.h"



#define N N_ARI
#define CHECK CHECK_ARI
#define EPS_CHECK EPS_CHECK_ARI 
#define SQUEEZE SQUEEZE_ARI
#define UNIFORM UNIFORM_ARI

extern double UNIFORM;


#if (C_ARI==1)
#define C -0.5
#define T(x) (-1./sqrt(x))
#define F(x) (-1./(x))
#define FM(x) (-1./(x))
#elif (C_ARI==0)
#define C 0. 
#define T(x) log(x)
#define F(x) exp(x)
#define FM(x) log(x)
#else
#define C C1_ARI
#define T(x) (-exp(C*log(x)))
#define F(x) (-exp(log(-(x))*(1.+1./C))*(1./(1.+1./C)))
#define FM(x) (-exp((C/(1.+C))*log(-(x)*(1.+1./C))))
#endif


#define MAX(a,b) (((a)<(b))?(b):(a))
#define PARLET(a,b) do{a.d1=b.d1;a.d2=b.d2;a.d3=b.d3;a.d4=b.d4;a.i1=b.i1;a.i2=b.i2;a.i3=b.i3;}while(0)

typedef struct{
       double vt, vc, vcr, xsq[2], y[2], ys[2], ac[2], pm, Hat[2],*hp,hpp[N];
       long int m, n[2], x[2], sign[2],s[2];
       char *hb,hbb[N];
       double (*hh)();
       PARAM par;
     }TOTAL;


void prariopt()
{
printf("Current value of C_ARI %d\n\n",C_ARI);
printf("Current value of c for the transformation is %f\n\n",C);
printf("The current size of the auxiliary table N_ARI is %d\n\n",N_ARI);
printf("The current value for CHECK_ARI is %d\n",CHECK_ARI);
printf("(0... no checking, 1... checking)\n");
printf("The current tollerance for checking EPS_CHECK_ARI is %e\n\n",EPS_CHECK_ARI);
printf("The current value for SQUEEZE_ARI is %d\n",SQUEEZE_ARI);
printf("(0... no squeeze, 1... squeeze)\n\n");

}


void *arisetup(hh,param,m,la,ra,pma)
double (*hh)(),pma;
#define P(x) (*(t->hh))(&(t->par),x)
PARAM *param;
long int m,la,ra/*mode, smallest, largest number with probability>0*/;
{ 
 TOTAL *t;
 double v[2],at[2];
 long int b[2],i,d;
 double t0;
 char setup=1;

 if (la>m||ra<m) 
   { printf("!!!ERROR arisetup(): mode or domain borders wrong!!\n");
     t=NULL;
     return(t);
   }
 t=malloc(sizeof(TOTAL));
 PARLET((t->par),(*param));
/*Step 0: setup*/
 t->sign[0]= -1;
 t->sign[1]=1;
 t->m=m;
 t->hh=hh;
 b[0]=la;
 b[1]=ra;
 t->pm=P(m);
 if(pma<=0.) /*this is the case where the exact probabilitis are known*/
   d=MAX(2,(long int)( 0.66/t->pm));
 else /*the probabilities are only known up to a constant factor and pma*/
   d=MAX(2,(long int)( 0.66/pma));/*is an estimate for the modal probability*/
/*step 0.1*/
 do
 {
   for(i=0;i<=1;i++)
   {
     t->x[i]=m+t->sign[i]*d;
     if(t->sign[i]*t->x[i]+1>t->sign[i]*b[i]) {  v[i]=0; t->s[i]=b[i];}
     else  
       { t->y[i]=T(P(t->x[i]));
	 t->ys[i]=t->sign[i]*(T(P(t->x[i]+t->sign[i]))-t->y[i]);
	 t->s[i]=(long int)(0.5+t->x[i]+(T(t->pm)-t->y[i])/t->ys[i]);
	 t->Hat[i]=F(t->y[i]+t->ys[i]*(t->s[i]+t->sign[i]*1.5-t->x[i]))/
	   t->ys[i]-t->sign[i]*P(t->s[i]+t->sign[i]); 
	 at[i]=t->x[i]+(FM(t->ys[i]*t->Hat[i])-t->y[i])/t->ys[i]; 
#if SQUEEZE
	 t->xsq[i]=t->sign[i]*(at[i]-(t->s[i]+t->sign[i]));
#endif
	 v[i]= t->sign[i]*(F(t->y[i]+t->ys[i]*(b[i]+t->sign[i]*0.5-t->x[i]))/
		       t->ys[i]-F(t->y[i]+t->ys[i]*(at[i]-t->x[i]))/t->ys[i]);
       }
     t->ac[i]=t->s[i]+t->sign[i]*(P(t->s[i])/t->pm-0.5);
   }   
/*step 0.2*/
   t->vc=t->pm*(t->ac[1]-t->ac[0]); 
   t->vt=t->vc+v[0]+v[1];
   t->vcr=t->vc+v[1];
/*step 0.3*/ 
   t->n[0]=MAX(b[0],m- N/2);
   t->n[1]=t->n[0]+N-1;
   if (t->n[1]>b[1]) {t->n[1]=b[1]; t->n[0]=t->n[1]-N+1;} 
   for(i=0;i<N;i++) t->hbb[i]=0;
   t->hb=t->hbb-t->n[0];
   t->hp=t->hpp-t->n[0];
   if (setup==1)
     {
       t0=(C<0?1./(1.-pow((1./(1.+C)),(1+1./(C+1.e-10)))):1.582); 
       if (pma>0.) t0*=pma/t->pm;
       if (t->vt<=t0) setup=0;
       else 
	 { setup=2;
	   if(pma>0.) d=(long int)t0/t->pm;
	   else d=(long int)t0/pma;
	 }
     }
   else setup=0;
 }while(setup);
#if CHECK
 printf("The total area below the hat is %f\n",t->vt);
 if (pma>0.) 
   { printf("Estimated epected number of iterations: %f,(precision of \n",
	    t->vt*pma/t->pm);
     printf("this estimate depends on the estimated modal probability)\n");
   }
#endif*/
 if(t->vt>100*t0||(t->vt<.9&&pma<0.)||(t->vt<0.))
   {
     printf("!!!ERROR arisetup() could not construct a hat!!\n");
     printf(" distribution not T-concave or some other error!!\n");
     free(t);
     t=NULL;
     return(t);
   }
 return(t);
}



long int arisample(t)
TOTAL *t;
{ 
 double U,X,h;
 long k,i;
#if CHECK
 if(t==NULL) { printf("!!ERROR arisample!! NULL-pointer was passed!\n");
	    return(NULL);}
#endif
/*step 1.0*/
 while(1)
 { U=UNIFORM*t->vt;
/*step 1.1*/
   if (U<=t->vc)
   { X=U*(t->ac[1]-t->ac[0])/t->vc+t->ac[0]; 
     k=(long int)(X+0.5);
     if(k<t->m) i=0; 
     else  i=1;
#if SQUEEZE
     if (t->sign[i]*(t->ac[i]-t->s[i])> t->sign[i]*(X-k)) return k;
#endif
     if (t->sign[i]*k<=t->sign[i]*t->n[i])
     { if(!t->hb[k]) { t->hp[k]=0.5-P(k)/t->pm; t->hb[k]=1;}
       h=t->hp[k];
#if CHECK
       if (h<-0.5-EPS_CHECK) 
       { printf("ERROR!!:For centerpart at %ld probab. higher than for mode\n",
		k);
	 return(0);
       }
#endif
     }
     else  
     { h=0.5-P(k)/t->pm;
#if CHECK
       if (h<-0.5-EPS_CHECK) 
       { printf("ERROR!!: For centerpart at %ld probab. higher than for mode\n"
		,k);
	 return(0);
       }
#endif
     }
     if (h<=t->sign[i]*(k-X)) return k;
   }
   else
/*step 1.2*/ 
   { if (U<= t->vcr)  {i=1; U=U-t->vc;} 
     else {i= 0;U=U-t->vcr;}
     U=t->Hat[i]+t->sign[i]*U; 
     X=t->x[i]+(FM(U*t->ys[i])-t->y[i])/t->ys[i];
     k=(long int)(X+0.5);
#if SQUEEZE
     if ((t->sign[i]*k<=t->sign[i]*t->x[i]+1)&&(t->xsq[i]<=t->sign[i]*(X-k))) 
       return k;
#endif
     if (t->sign[i]*k<= t->sign[i]*t->n[i])
     {
       if(!t->hb[k]) 
       { t->hp[k]=t->sign[i]*F(t->y[i]+t->ys[i]*(k+t->sign[i]*0.5-t->x[i]))/
	          t->ys[i]-P(k); 
#if CHECK
/*tests if Hat too low i.e.: (H(k+0.5)-p_k<H(k-1/2))*/
	 if (t->hp[k]+EPS_CHECK<t->sign[i]*F(t->y[i]+
			        t->ys[i]*(k-t->sign[i]*0.5-t->x[i]))/t->ys[i]) 
	 { printf("ERROR!!!: For tailpart at %ld probab. higher than hat\n",k);
	   return(0);}
#endif
	 t->hb[k]=1;
       }
       h=t->hp[k];
     }
     else 
     { h=t->sign[i]*F(t->y[i]+t->ys[i]*(k+t->sign[i]*0.5-t->x[i]))/
	 t->ys[i]-P(k);
#if CHECK
/*tests if Hat too low i.e.: (H(k+0.5)-p_k<H(k-1/2))*/
       if (h+EPS_CHECK<t->sign[i]*F(t->y[i]+
		       t->ys[i]*(k-t->sign[i]*0.5-t->x[i]))/t->ys[i]) 
       { printf("ERROR!!!: For tailpart at %ld probab. higher than hat\n",k);
	 return(0);
       }
#endif

     }
     if (t->sign[i]*U>=h) return k;
   }
 }
}












